import java.util.Iterator;

import market.CArticleCatalog;
import market.CIArticle;
import market.CalendarTime;
import market.SMarket;
import market.UCustomer;
import market.UMUserBase;
import market.UPerson;
import market.UStaffer;
import sale.Time;
import users.User;
import users.UserManager;
import data.IntegerValue;

/**
 * This class includes the main-method of this application
 * it also creates some test-data
 */
public class MainClass {

    private static String frau = UPerson.FRAU;
    private static String herr = UPerson.HERR;
    private static String whw = UStaffer.WAREHOUSE_WORKER;
    private static String slr = UStaffer.SELLER;
    private static String mgr = UStaffer.MANAGER;
    //data for staffers
    private static String[] salutationS = new String[] {frau, frau, herr, frau, herr, herr, herr, frau, herr};
    private static String[] salutationC = new String[] {herr, herr, frau, herr};
    private static String[] surnameS = new String[] {"Maier", "Richter", "Gans", "Brunft", "Giebel",
            "Bommel", "Raupe", "Pahn", "Sohn"};
    private static String[] surnameC = new String[] {"Mustermann", "Grandlhuber", "Saubermann", "Knirps"};
    private static String[] forenameS = new String[] {"Magda", "Rita", "Gabriel", "Brunhilde", "Giesbert",
            "Bodo", "Ralf", "Petra", "Samuel"};
    private static String[] forenameC = new String[] {"Max", "Gregor", "Sandra", "Knut"};
    private static String[] phoneS = new String[] {"05555/33214", "05555/11147", "05555/63539", "05555/80063",
            "05555/17530", "05555/54219", "05555/99124", "05555/71395", "05555/65482"};
    private static String[] phoneC = new String[] {"05555/11111", "05555/44724", "05555/38047", "05555/22446"};
    private static String[] streetS = new String[] {"Herrschergasse 8", "Gnseblmleinweg 15b", "Heimweg 3",
            "Hohlegasse 35", "Berliner Strae 9", "Hanfweg 28a", "Bahnhofsstrae 23", "Kummergasse 17",
            "Villenweg 1"};
    private static String[] streetC = new String[] {"Musterweg 1", "Handerwerkerstrae 19", "Frische Strae 28",
            "Blitzweg 31"};
    private static int[] postcodeS = new int[] {55123, 55123, 55123, 55123, 55123, 55123, 55123, 55123,
            55123};
    private static int[] postcodeC = new int[] {11111, 55123, 55123, 55123};
    private static String[] cityS = new String[] {"Eckstadt", "Eckstadt", "Eckstadt", "Eckstadt",
            "Eckstadt", "Eckstadt", "Eckstadt", "Eckstadt", "Eckstadt"};
    private static String[] cityC = new String[] {"Musterhausen", "Eckstadt", "Eckstadt", "Eckstadt"};
    private static String[] loginS = new String[] {"mm1", "rr1", "gg1", "bb1", "gg2", "bb2", "rr2",
            "pp1", "BOSS"};
    private static String[] loginC = new String[] {"c_mm1", "c_gg1", "c_ss2", "c_kk1"};
    private static int[] salary = new int[] {170000, 202528, 254417, 170000, 221200, 234567, 221212,
            198097, 1500000};
    private static String[] company = new String[] {"Musterhauskchenfachgeschft",
            "Fliesenlegerei Grandlhuber", "Reinigungsfirma Saubermann", "Fotoatelier Knirps"};
    private static String[] qualification = new String[] {slr, slr, slr, slr, whw, whw, whw, whw, mgr};


    /**
     * The main-method of this application
     */
    public static void main(String[] args){
        Time time = new CalendarTime();
        SMarket market = new SMarket(time);
        UserManager.setGlobalUM(new UMUserBase());
        SMarket.addToAccount(new IntegerValue(10000000));
        createData();
        assignDescriptions();
        market.start();
        createTestUsers();
    }

    /**
     * Adds articles to the article-catalog and to the market`s offer
     */
    private static void createData() {
      CArticleCatalog cArticles = SMarket.getArticleCatalog();
      cArticles.add(new CIArticle("0001", "Bettlaken", "Haushaltswaren", 2000, 1500));
      cArticles.add(new CIArticle("0002", "Handtuch", "Haushaltswaren", 1000, 800));
      cArticles.add(new CIArticle("0003", "Kochset", "Haushaltswaren", 5000, 4700));
      cArticles.add(new CIArticle("0004", "Computer", "Elektronik", 200000, 175000));
      cArticles.add(new CIArticle("0005", "PDA", "Elektronik", 40000, 35000));
      cArticles.add(new CIArticle("0006", "Fernseher", "Elektronik", 40000, 30000));
      cArticles.add(new CIArticle("0007", "Druckerpatrone", "Brobedarf", 4000, 3200));
      cArticles.add(new CIArticle("0008", "Druckerpapier", "Brobedarf", 200, 150));
      cArticles.add(new CIArticle("0009", "Drehstuhl", "Brobedarf", 3000, 2500));
      cArticles.add(new CIArticle("0010", "Playmobil Ritterburg", "Spielwaren", 2000, 1700));
      cArticles.add(new CIArticle("0011", "Steiff-Tier", "Spielwaren", 35000, 30000));
      cArticles.add(new CIArticle("0012", "Lego Hubschrauber", "Spielwaren", 3500, 2500));
      SMarket.getOffer().add("0001", 20, null);
      SMarket.getOffer().add("0002", 150, null);
      SMarket.getOffer().add("0003", 50, null);
      SMarket.getOffer().add("0004", 800, null);
      SMarket.getOffer().add("0006", 100, null);
      SMarket.getOffer().add("0007", 85, null);
      SMarket.getOffer().add("0009", 110, null);
      SMarket.getOffer().add("0010", 1000, null);
      SMarket.getOffer().add("0011", 500, null);
      SMarket.getOffer().add("0012", 558, null);
      SMarket.getOffer().addZeros(null);
    }

    /**
     * Sets descritions for the existing articles
     */
    private static void assignDescriptions() {
        Iterator it = SMarket.getArticleCatalog().iterator(null, false);
        String name;
        while (it.hasNext()) {
              CIArticle cia = (CIArticle)it.next();
              name = cia.getArticleName();
              if (name.equals("Bettlaken")) cia.setDescription(new String[] {
                          "Dreamland", "Diese Qualittsspannbettlaken sind fr alle Bettgren " +
                          "geeignet. Sie wurden chlorfrei gebleicht und erfllen auch sonst alle " +
                          "Umweltnormen."});
              if (name.equals("Handtuch")) cia.setDescription(new String[] {
                          "Textil & Mehr", "100% Baumwolle von glcklichen Schafen."});
              if (name.equals("Kochset")) cia.setDescription(new String[] {
                          "Cook'n'Co", "Kochset mit zwei Tiegeln, 5 Tpfen, einem Messerset. " +
                          "Alles teflonbeschichtet."});
              if (name.equals("Computer")) cia.setDescription(new String[] {
                          "Compumac", "Aktueller PC mit modernen Komponenten:\n" +
                          "Festplatte: 2x120GB\nArbeitsspeicher 1024MB\nDVD-Brenner und -laufwerk\n" +
                          "21\" Monitor"});
              if (name.equals("PDA")) cia.setDescription(new String[] {
                          "Toshiba", "PocketPC e310, 200MHz Prozessor, 32MB interner Speicher."});
              if (name.equals("Fernseher")) cia.setDescription(new String[] {
                          "Soffy", "Grobildfernseher (110cm Bildschirmdiagonale) mit Fernbedienung."});
              if (name.equals("Druckerpatrone")) cia.setDescription(new String[] {
                          "Inky", "Druckerpatronen fr alle erhltlichen Drucker von Inky."});
              if (name.equals("Druckerpapier")) cia.setDescription(new String[] {
                          "Inky", "1000 Blatt, chlorfrei gebleicht."});
              if (name.equals("Playmobil Ritterburg")) cia.setDescription(new String[] {
                          "Playmobil", "Ritterburgmodell, nimmt aufgebaut eine Flche von 2,8m ein.\n" +
                          "Nicht fr Kinder unter 3 Jahren geeignet."});
              if (name.equals("Steiff-Tier")) cia.setDescription(new String[] {
                          "Steiff", "Knopf im Ohr. Waschbar bei 40C."});
              if (name.equals("Lego Hubschrauber")) cia.setDescription(new String[] {
                          "Lego", "Modellhubschrauber im Mastab 1:25\n" +
                          "Nicht fr Kinder unter 3 Jahren geeignet."});
              if (name.equals("Drehstuhl")) cia.setDescription(new String[] {
                           "Mblius", "Bequemer hhenverstellbarer Drehstuhl. Ergonomisch geformt."});
        }
    }

    /**
     * Creates some test-persons
     */
    private static void createTestUsers() {

        //Customers
        for(int i=0;i<4;i++){
            UCustomer uc = (UCustomer)UMUserBase.createUser(loginC[i], UMUserBase.CUSTOMER, null);
            uc.setFullName(salutationC[i], surnameC[i], forenameC[i]);
            uc.setAddress(streetC[i], postcodeC[i], cityC[i]);
            uc.setTelephone(phoneC[i]);
            uc.setCompany(company[i]);
            uc.setPassWd(User.garblePassWD(new char[0]));
        }

        //Staffers
        for (int i=0 ;i<9; i++){
            UStaffer us = (UStaffer)UMUserBase.createUser(loginS[i], UMUserBase.SELLER, qualification[i]);
            us.setFullName(salutationS[i], surnameS[i], forenameS[i]);
            us.setAddress(streetS[i], postcodeS[i], cityS[i]);
            us.setTelephone(phoneS[i]);
            us.setSalary(salary[i]);
            us.setPassWd(User.garblePassWD(new char[0]));
        }
    }
}