package market;

import data.CatalogItem;
import data.ooimpl.CatalogImpl;

/**
 * A CatalogImpl, where the CIArticles of the market are stored. The market's offer, and therefore
 * this catalog, never changes.
 */
public class CArticleCatalog extends CatalogImpl {

    /**
     * @param name the ID of the CArticleCatalog
     */
    public CArticleCatalog(String name) {
        super(name);
    }

    /**
     * Adds a CatalogItem to the catalog. Used as a shortcut for <code>add(item, null)</code>.
     * @param item the CatalogItem to be added.
     */
    public void add(CatalogItem item) {
        add(item, null);
    }

    /**
     * Removes a CatalogItem from the catalog. Used as a shortcut for <code>remove(name, null)</code>
     * including the try-catch-block.
     * @param name the name of the CatalogItem to be removed.
     */
    public void remove(String name) {
        try {
            remove(name, null);
        }
        catch (Exception e) {
            System.err.println(e.getMessage());
        }
    }

    /**
     * Gets a CatalogItem by its name. Used as a shortcut for <code>get(name, null)</code>
     * including the try-catch-block.
     *
     * @param name the name of the searched CatalogItem.
     * @return the searched CatalogItem if found, otherwise <code>null</code>.
     */
    public CIArticle get(String name) {
        try {
            return (CIArticle)get(name, null, false);
        }
        catch (Exception e) {
            System.err.println(e.getMessage());
            return null;
        }
    }
}
