package market;

import data.Catalog;
import data.CatalogItem;
import data.filters.CatalogFilter;

/**
 * Filters CatalogItems by their category.
 */
public class CFilter extends CatalogFilter {

    private Catalog source;
    private int filter;

    /**
     * @param source the source catalog.
     * @param filter the filter to be applied:
     * <ul><li>0: no CatalogItems are filtered</li>
     *     <li>1: CatalogItems are filtered by their category</li></ul>
     */
    public CFilter(Catalog source, int filter) {
        super(source);
        this.source = source;
        this.filter = filter;
    }

    /**
     * The actual filtering.
     * @param ci the CatalogItem to be checked.
     * @return <code>true</code> if CatalogItem passed the filter successfully, otherwise <code>false</code>.
     */
    public boolean match(CatalogItem ci) {
        String category = ((CIArticle)ci).getCategory();
        switch (filter) {
            case 0: return true;
            default: return category.equals(SMarket.getArticleCategories()[filter]);
        }
    }
}