package market;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;


/**
 * The time for the market.
 */
public class CalendarTime extends sale.CalendarTime {

    public CalendarTime() {
        super(Conversions.createToday().getTime().getTime());
    }

    /**
     * @return the current time.
     */
    public Object getTime() {
        Date d = (Date)super.getTime();
        SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy");
        String datString = sdf.format(d);
        return Conversions.stringToCalendar(datString);
    }

    /**
     * Sets a new time.
     * @param oTime the time to be set.
     * @throws IllegalArgumentException
     */
    public void setTime(Object oTime) throws IllegalArgumentException {
        super.setTime(((Calendar)oTime).getTime());
    }
}
