package market;

import java.util.Calendar;

import javax.swing.JOptionPane;

import market.stdform.ButtonIDs;
import market.stdform.FSCheckable;
import market.stdform.FSTime;
import sale.Action;
import sale.FormSheet;
import sale.FormSheetContentCreator;
import sale.SaleProcess;
import sale.SalesPoint;

/**
 * The tiny window in which one can set the market's time.
 */
public class SPTime extends SalesPoint {

    public SPTime() {
        super("Zeitsimulation");
    }

    /**
     * @return <code>true</code>, so this SalesPoint can always be closed.
     */
    public boolean onCanQuit() {
        return true;
    }

    /**
     * Creates and returns the default FormSheet.
     * @return the default FormSheet.
     */
    public FormSheet getDefaultFormSheet() {
        final FSCheckable fsc = new FSCheckable(new FSTime());
        fsc.addContentCreator(new FormSheetContentCreator() {
            public void createFormSheetContent(final FormSheet fs) {
                fs.getButton(ButtonIDs.BTN_OK).setAction(new Action() {
                    public void doAction(SaleProcess p, SalesPoint sp) {
                        if (fsc.checkTextFields(FSCheckable.ALL_ERRORMESSAGES_AT_ONCE, false)) {
                            String sDate = fsc.getEntry(1);
                            Calendar dSet = Conversions.stringToCalendar(sDate);
                            Calendar today = SMarket.getTime();
                            if (!dSet.after(today)) {
                                JOptionPane.showMessageDialog(fs.getComponent(),
                                        "Es wird ein knftiges Datum erwartet.", "Fehler", 0);
                            } else {
                                SMarket.setTime(dSet);
                                closeTime();
                            }
                        }
                    }
                });
            }});
        return fsc;
    }

    /**
     * Closes this SalesPoint.
     */
    private void closeTime() {
        //This is written as an extra method because it uses <this>, but it is called from within
        //an anonymous inner class
        SMarket.getTheShop().removeSalesPoint(this);
    }
}