package market;

/**
 * Implementations of this interface provide an easy way to check if a String complies with a special
 * format.<br>
 * If it doesn't, a ValueChecker can return a String describing the kind of error that was detected.
 */
public interface ValueChecker extends java.io.Serializable {

    /**
     *
     * @param content the String to be tested
     * @return <code>true</code> if the String is valid conforming with the particular ValueChecker's
     * implementation, otherwise <code>false</code>.
     */
    boolean isValidValue(String content);

    /**
     * @return a descriptive String depending on the kind of detected error
     */
    String getErrorString();
}