package market.event;

import market.SProcessWorker;

/**
 * Listener interface that enables Objects to listen to offer specific events and react on them.
 */
public interface OfferEventListener {

    /**
     * Invoked when the global count of an article is needed.
     *
     * @param articleKey the key of the article which count is needed.
     * @param spw the SProcessWorker from which the request came from.
     */
    void countArticles(String articleKey, SProcessWorker spw);

    /**
     * Invoked when a shortage of an article occured.
     *
     * @param articleKey the key of the article which is currently unavaible.
     */
    void offerEmpty(String articleKey);

    /**
     * Invoked when a delivery enters the market.
     */
    void wakeUpOrders();
}
