package market.resource;

import java.awt.Toolkit;
import java.net.URL;

import javax.swing.JFrame;

/**
 * Handles the assignment of the image icon to frames.
 */
public abstract class IconSetter {

    /**
     * @return the full path to the image icon.
     */
    public static URL getIconPath() {
        MarketResourceManager rm = MarketResourceManager.getMRMInstance();
        ResourceModuleIcon rmg = new ResourceModuleIcon();
        return rm.getResource(rmg.getTypeName(), "icon");
    }

    /**
     * Sets the image icon as a JFrame's icon.
     * @param jf the JFrame to which the icon is set.
     */
    public static void setIcon(JFrame jf) {
        jf.setIconImage(Toolkit.getDefaultToolkit().createImage(getIconPath()));
    }
}