package market.statistics;

import market.UCustomer;
import data.Value;
import data.events.VetoException;
import data.ooimpl.CatalogImpl;

/**
 * Catalog that contains the statistics of the market's customers.
 */
public class CCustomerStats extends CatalogImpl {

    public CCustomerStats() {
        super("Kundenstatistik");
    }

    /**
     * @param id the ID of the customer whose statistics are to be got.
     * @return the desired customer statistics.
     */
    public CICustomerStats get(String id) {
        try {
            return (CICustomerStats)super.get(id, null, false);
        }
        catch (VetoException ex) {
            return null;
        }
    }

    /**
     * @param id the ID of the customer whose statistics are to be removed.
     */
    public void remove(String id) {
        try {
            super.remove(id, null);
        }
        catch (VetoException ex) {}
    }

    /**
     * Updates the customer's statistics whenever he made a purchase.
     *
     * @param uc the customer to whose statistics the value should be added.
     * @param v the value to be added to the statistics.
     */
    public void addSales(UCustomer uc, Value v) {
        get(uc.getName()).add(Integer.parseInt(v.toString()));
    }
}