package market.stdform;

import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import market.Conversions;
import sale.FormSheet;
import sale.FormSheetContentCreator;
import data.Value;

/**
 * This FormSheet displays how much the customer has to pay for his/her current selection.
 */
public class FSCustomerConfirmSelection extends FormSheet{

    /**
     * @param amount the {@link Value} the customer has to pay
     */
    public FSCustomerConfirmSelection(final Value amount){
        super("Auswahl besttigen", null);
        FormSheetContentCreator fscc = new FormSheetContentCreator(){
            protected void createFormSheetContent(FormSheet fs) {
                String text = new String("Sie haben Artikel im Wert von: "+
                Conversions.valueToCurrency(amount)+" Euro ausgewhlt.\n"+
                "Mit Kaufen knnen Sie die Auswahl besttigen!\n"+
                "Mit Zurck knnen Sie die Auswahl korrigieren!\n");
                JTextArea jta = new JTextArea (text);
                jta.setEditable (false);
                fs.setComponent (new JScrollPane(jta));

                fs.removeAllButtons();
                fs.addButton("Kaufen",ButtonIDs.BTN_BUY,null);
                fs.addButton("Zurck",ButtonIDs.BTN_BACK,null);
            }
        };
        this.addContentCreator(fscc);
    }
}
