package market.stdform;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;

import javax.swing.JLabel;
import javax.swing.JPanel;

import market.Conversions;
import market.UCustomer;
import market.statistics.Statistics;
import market.swing.ComponentFactory;
import sale.FormSheet;
import sale.FormSheetContentCreator;

/**
 * This FormSheet displays detailed statistics of a customer.
 */
public class FSManagerCustomerStatsDetail extends FormSheet {

    /**
     * @param uc the customer whose statistics are to be displayed.
     */
    public FSManagerCustomerStatsDetail(final UCustomer uc) {
        super("Kundenstatistik - Details", null);
        this.addContentCreator(new FormSheetContentCreator() {public void createFormSheetContent(final FormSheet fs) {
            JPanel jpMain = new JPanel();
            JPanel jpData = new JPanel();

            GridBagConstraints c = new GridBagConstraints();
            GridBagLayout gridbag = new GridBagLayout();
            jpMain.setLayout(gridbag);
                c.gridy = 0;
                c.weightx = 1;
                c.weighty = 0.1;
                c.insets = new Insets(10,0,0,0);
                c.anchor = GridBagConstraints.CENTER;
              gridbag.setConstraints(jpData, c);

            jpData.setLayout(new GridLayout(7, 2, 10, 10));
            jpData.setBorder(ComponentFactory.createInsetBorder("Kundenstatistik"));
            jpData.add(new JLabel("Name: "));
            jpData.add(ComponentFactory.createTextField(uc.getFullName(), 10, false, ComponentFactory.RIGHT,
                    false));
            jpData.add(new JLabel("Firma: "));
            jpData.add(ComponentFactory.createTextField(uc.getCompany(), 10, false, ComponentFactory.RIGHT,
                    false));
            jpData.add(new JLabel("Mitglied seit: "));
            jpData.add(ComponentFactory.createTextField(uc.getDayOfRegistration().toString(),
                    10, false, ComponentFactory.RIGHT, false));
            jpData.add(new JLabel("Mitgliedsdauer: "));
            jpData.add(ComponentFactory.createTextField(uc.getMonthsOfMembership() + " Monate", 10, false,
                    ComponentFactory.RIGHT, false));
            jpData.add(new JLabel("Gesamtumsatz: "));
            jpData.add(ComponentFactory.createTextField(
                    Conversions.doubleToCurrency(Statistics.getCompleteCustomerRevenue(uc), " Euro"),
                    10, false, ComponentFactory.RIGHT, false));
            jpData.add(new JLabel("Auf Rabatt anrechenbarer Umsatz: "));
            jpData.add(ComponentFactory.createTextField(
                    Conversions.doubleToCurrency(Statistics.getAllowableCustomerRevenue(uc), " Euro"),
                    10, false, ComponentFactory.RIGHT, false));
            jpData.add(new JLabel("Rabatt: "));
            jpData.add(ComponentFactory.createTextField(
                    Conversions.fixedDecimal(100 * uc.getDiscount(), 3) + " %",
                    10, false, ComponentFactory.RIGHT, false));
            jpMain.add(jpData);
            fs.removeAllButtons();
            fs.addButton("Statistikbersicht", ButtonIDs.BTN_BACK, null);
            fs.setComponent(jpMain);
        }});
    }
}
