package market.stdform;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;

import market.SMarket;
import market.event.MarketEventAdapter;
import sale.Action;
import sale.ActionActionListener;
import sale.FormSheet;
import sale.FormSheetContentCreator;
import sale.SaleProcess;
import sale.SalesPoint;

/**
 * This FormSheet is used by the manager to open and close the market, announce the leisure-time
 * and change the date to the next day.
 */
public class FSManagerOpenClose extends FormSheet {

    JButton jb = new JButton();
    private static String OPEN = "Feierabend ankndigen";
    private static String TOBECLOSED = "Ankndigung zurcknehmen";

    public FSManagerOpenClose() {
        super("Schlieen", new FormSheetContentCreator() {public void createFormSheetContent(final FormSheet fs) {
            fs.setComponent(fs.getComponent());
        }}, false);
        this.addContentCreator(new FormSheetContentCreator() {public void createFormSheetContent(final FormSheet fs) {
            //define components
            JPanel jpMain = new JPanel();
            JPanel jpBigButton = new JPanel();
            GridBagConstraints c = new GridBagConstraints();
            GridBagLayout gridbag = new GridBagLayout();
            //add components
            jpMain.setLayout(gridbag);
                c.anchor = GridBagConstraints.CENTER;
            gridbag.setConstraints(jpBigButton, c);
            jb.setText(SMarket.isToBeClosed() ? TOBECLOSED : OPEN);
            jb.setVisible(SMarket.isOpen());
            jb.setPreferredSize(new Dimension(250, 100));
            //add action listener if there is none yet
            //(checking for action listeners prevents from adding them twice
            //(This would happen when persistence file is loaded))
            if (jb.getListeners(ActionListener.class).length == 0) {
                jb.addActionListener(new ActionActionListener(fs, new Action() {
                    public void doAction(SaleProcess p, SalesPoint sp) {
                        if (SMarket.isToBeClosed()) {
                            SMarket.getTheMarket().setOpen(0);
                            SMarket.fireMarketNotClosing();
                        } else {
                            SMarket.getTheMarket().setOpen(1);
                        }
                    }
                }));
            }
            jpBigButton.add(jb);
            jpMain.add(jpBigButton);
            fs.setComponent(jpMain);
            removeAllButtons();
            fs.addButton("Markt ffnen", ButtonIDs.BTN_START, null);
            fs.addButton("Markt schlieen", ButtonIDs.BTN_END, null);
            fs.addButton("Zum nchsten Tag", ButtonIDs.BTN_NEXT, null);
            fs.getButton(ButtonIDs.BTN_START).setEnabled(SMarket.hasTimeAdvanced());
            fs.getButton(ButtonIDs.BTN_END).setEnabled(SMarket.isOpen());
            fs.getButton(ButtonIDs.BTN_NEXT).setVisible(!SMarket.isOpen());
        }});
        SMarket.addEventListener(new MarketEventAdapter() {
            public void notifyOnMarketClosing() {
                jb.setText(TOBECLOSED);
            };

            public void notifyOnMarketNotClosing() {
                jb.setText(OPEN);
            }

            public void marketClosed() {
                jb.setEnabled(false);
                jb.setVisible(false);
                getButton(ButtonIDs.BTN_END).setEnabled(false);
                getButton(ButtonIDs.BTN_NEXT).setVisible(true);
            }

            public void marketOpened() {
                jb.setEnabled(true);
                jb.setVisible(true);
                jb.setText("Feierabend ankndigen");
                getButton(ButtonIDs.BTN_START).setEnabled(false);
                getButton(ButtonIDs.BTN_END).setEnabled(true);
                getButton(ButtonIDs.BTN_NEXT).setVisible(false);
            }

            public void timeAdvanced() {
                getButton(ButtonIDs.BTN_START).setEnabled(true);
            }

            public void offerEmpty(String s, int who) {
            }

            public void workerInformationChanged() {
            }
        });
    }
}

