package market.stdform;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;

import market.Conversions;
import market.SMarket;
import market.swing.ComponentFactory;
import sale.FormSheet;
import sale.FormSheetContentCreator;

/**
 * This FormSheet gives a short overview of the {@link FSManagerPurchase purchase} the manger wants to
 * send and asks for confirmation.
 */
public class FSManagerPurchaseConfirm extends FormSheet {

    /**
     * @param toPay the value of the purchase.
     */
    public FSManagerPurchaseConfirm(final int toPay) {
        super("Besttigung", new FormSheetContentCreator() {public void createFormSheetContent(final FormSheet fs) {
            JPanel jpMain = new JPanel();
            JPanel jpText = new JPanel();
            JPanel jpData = new JPanel();
            GridBagConstraints c = new GridBagConstraints();
            GridBagLayout gridbag = new GridBagLayout();
            jpMain.setLayout(gridbag);
                c.gridy = 0;
                c.weighty = 0.1;
                c.anchor = GridBagConstraints.CENTER;
            gridbag.setConstraints(jpText, c);
                c.gridy = 1;
                c.weighty = 0.8;
                c.anchor = GridBagConstraints.CENTER;
            gridbag.setConstraints(jpData, c);

            jpMain.add(jpText);
                jpText.add(new JLabel("Soll diese Bestellung wirklich abgeschickt werden?"));
            jpMain.add(jpData);
                jpData.setLayout(new GridLayout(2,2,5,5));
                jpData.setBorder(ComponentFactory.createInsetBorder());
                jpData.add(new JLabel("Gesamtpreis"));
                jpData.add(ComponentFactory.createTextField(Conversions.doubleToCurrency(toPay, " Euro"),
                        10, false, ComponentFactory.RIGHT, false));
                jpData.add(new JLabel("Vermgen"));
                jpData.add(ComponentFactory.createTextField(Conversions.valueToCurrency(
                        SMarket.getAccount(), " Euro"),10,false,ComponentFactory.RIGHT, false));
            fs.setComponent(jpMain);
            fs.removeAllButtons();
            fs.addButton("Besttigen", ButtonIDs.BTN_OK, null);
            fs.addButton("Zurck", ButtonIDs.BTN_BACK, null);
            fs.addButton("Abbrechen", ButtonIDs.BTN_CANCEL, null);
        }}, false);
    }
}
