package market.stdform;

import java.awt.GridLayout;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

import market.swing.ComponentFactory;
import sale.FormSheet;
import sale.FormSheetContentCreator;

/**
 * This FormSheet displays a worker information, with the count of
 * unexecuted orders and the number of workers, that are logged on to the system.
 */
public class FSWorkerDefault extends FormSheet{

    /**
     * @param sCaption the caption of this FormSheet.
     * @param jcmpComponent will be set as the component.
     */
    public FSWorkerDefault(String sCaption,
                 JComponent jcmpComponent) {
        super(sCaption, jcmpComponent);
    }

    /**
     * @param order the count of unexecuted orders.
     * @param worker the number of logged on workers.
     */
    public FSWorkerDefault(final int order, final int worker) {
        super("Lager", null);
        this.addContentCreator(new FormSheetContentCreator(){
            protected void createFormSheetContent(FormSheet fs) {
                JPanel jp_main = new JPanel();
                jp_main.setLayout(new BoxLayout(jp_main, BoxLayout.Y_AXIS));
                JPanel jp_information = new JPanel();
                jp_information.setBorder(ComponentFactory.createInsetBorder("Information"));
                jp_information.setLayout(new GridLayout(2,1));
                jp_information.setAlignmentX(Box.CENTER_ALIGNMENT);
                jp_information.setAlignmentY(Box.CENTER_ALIGNMENT);

                JLabel jl_order = new JLabel("Es sind momentan "+order+" Lieferungen zusammenzustellen.");
                JLabel jl_worker = new JLabel(worker+" Arbeiter sind mit Lieferungen beschftigt.");

                jp_information.add(jl_order);
                jp_information.add(jl_worker);

                jp_main.add(Box.createVerticalStrut(160));
                jp_main.add(jp_information);
                jp_main.add(Box.createVerticalStrut(160));

                fs.setComponent(jp_main);
                fs.removeAllButtons();
                fs.addButton("Lieferung zusammenstellen", ButtonIDs.BTN_OK, null);
            }
        });
    }
}
