package market.stdform;

import market.SMarket;
import sale.GateChangeTransition;
import sale.MenuSheet;
import sale.MenuSheetItem;
import sale.SaleProcess;
import sale.SalesPoint;
import sale.Transition;
import sale.UIGate;

/**
 * This MenuSheet class provides a simple log-off MenuSheet.
 */
public class MSLogOff extends MenuSheet{

    /**
     * Creates a MenuSheet with one MenuSheetItem, which`s action closes the SalesPoint related to the MenuSheet.
     *
     * @param trans Transition that gets set in the MenuSheetItem`s action to the current Gate of a SaleProcess,
     * if someone runs on the SalesPoint related to this MenuSheet.
     */
    public MSLogOff(final Transition trans) {
        super("System", null, 'S');
        this.add(new MenuSheetItem("Abmelden", "exit", new sale.Action() {
            public void doAction(SaleProcess p, SalesPoint sp) throws Throwable {
                if(p!=null){
                    ((UIGate)p.getCurrentGate()).setNextTransition(trans);
                }
                if (sp != null) {//sp is only null if a JDDShowMessage is active
                    if(sp.getCurrentProcess()!=null) sp.processFinished(p);
                    SMarket.getTheMarket().removeSalesPoint(sp);
                    sp.quit();
                }
            }
        }, 'A'));
    }

    /**
     * Overloads constructor with GateChangeTransition.CHANGE_TO_STOP_GATE as argument.
     */
    public MSLogOff() {
        this(GateChangeTransition.CHANGE_TO_STOP_GATE);
    }
}
