package market.swing;

import java.io.Serializable;
import java.util.Comparator;

import market.CIOpenPurchaseOrders;

/**
 * Compares {@link market.CIOpenPurchaseOrders} by their stocks' values
 */
public class CmpOpoNumbers implements Comparator, Serializable {

    /**
     * The actual comparison.
     * @param o1 the first CIOpenPurchaseOrder.
     * @param o2 the second CIOpenPurchaseOrder.
     * @return an int representing the result of the comparison.
     */
    public int compare(Object o1, Object o2) {
        CIOpenPurchaseOrders c1 = (CIOpenPurchaseOrders)o1;
        CIOpenPurchaseOrders c2 = (CIOpenPurchaseOrders)o2;
        return c1.getOrdersValue().compareTo(c2.getOrdersValue());
    }
}